<?php

namespace App\Filament\Exports;

use App\Models\ProductionCharacteristic;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class ProductionCharacteristicExporter extends Exporter
{
    protected static ?string $model = ProductionCharacteristic::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;
        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('plant.code')
                ->label('PLANT CODE'),
            ExportColumn::make('line.name')
                ->label('LINE NAME'),
            ExportColumn::make('item.code')
                ->label('ITEM CODE'),
            ExportColumn::make('machine.work_center')
                ->label('WORK CENTER'),
            ExportColumn::make('production_order')
                ->label('PRODUCTION ORDER'),
            ExportColumn::make('serial_number')
                ->label('SERIAL NUMBER'),
            ExportColumn::make('characteristic_name')
                ->label('CHARACTERISTIC NAME'),
            ExportColumn::make('observed_value')
                ->label('OBSERVED VALUE'),
            ExportColumn::make('status')
                ->label('STATUS'),
            ExportColumn::make('inspection_status')
                ->label('INSPECTION STATUS'),
            ExportColumn::make('remark')
                ->label('REMARK'),
            ExportColumn::make('created_at')
                ->label('CREATED AT'),
            ExportColumn::make('updated_at')
                ->label('UPDATED AT'),
            ExportColumn::make('created_by')
                ->label('CREATED BY'),
            ExportColumn::make('updated_by')
                ->label('UPDATED BY'),
            ExportColumn::make('deleted_at')
                ->label('DELETED AT'),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your production characteristic export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
